// ENCODING: UTF-8
'use strict';

// BUILT-IN MODULES
var ut = require('util');

/**
 * Prints object to STDOUT, showing hidden props and with unlimited depth.
 *
 * @param {object} o
 */
console.dbg = function(o){
	console.log(ut.inspect(o, true, null));
	require('fs').appendFile('./log/dbg.log', ut.inspect(o, true, null)+'\n\n', 'ucs2'); //binary utf-8
	//require('fs').writeFile('./log/dbg.log', ut.inspect(o, true, null), 'binary');	
}

console.die = function(o){
	console.log(o);
	process.exit();
}

console.err = function(err) {
  if (typeof err === 'object') {
    if (err.message) {
      console.log('\nMessage: ' + err.message)
    }
    if (err.stack) {
      console.log('\nStacktrace:')
      console.log('====================')
      console.log(err.stack);
    }
  }
}

// global shortcuts
global.log = console.log;
global.dbg = console.dbg;
global.die = console.die;
global.die = console.err;
