/**
 * Constructor for File objects
 *
 * @constructor
 * @this {File}
 * @param {string} name - The file's filename on CD.
 * @param {string} path - The file's original filesystem path.
 * @param {number} size - The file's size (in bytes).
 * @param {<Date>} date - Last modified Date (can be undefined)
 */
function File(name, path, size, date){
	this.name = name;
	this.path = path;
	this.size = size;
	this.date = date;
}

module.exports = File;