// ENCODING: UTF-8
'use strict';

// BUILT-IN MODULES
var fs = require('fs');

// MIXED UTILITY FUNCTION LIBRARY
module.exports = {
	
sortByKey: function(obj){
	var keys = Object.keys(obj);
	keys.sort();
	var objNew = {};
	for (var i in keys) objNew[keys[i]] = obj[keys[i]];
	return objNew;
},

// returns list of files (full path) in dir (recursive)
// dir ends on '/'
readDir: function(dir, files){
	var self = this;
	var File = require('./file');
	if (dir.charAt(dir.length-1)!='/') dir += '/';
	var items = fs.readdirSync(dir);
	items.forEach(function(name){
		var path = dir+name;
		var stats = fs.statSync(path);
		if (stats.isFile()){
			//files.push([dir+'/'+f, stats]);
			files.push( new File(name, path, stats.size) );
		}else if (stats.isDirectory()){
			self.readDir(path+'/', files);
		}
	});
},

// 'C:/foo/bar/do.txt'
// [ 'C:', 'foo', 'bar' ]
// [ 'foo', 'bar' ]
createStreamAndFolders: function(fn){
	var folders = fn.split('/');
	folders.pop();
	var vol = folders.shift();
	if (!fs.existsSync(vol)){
		throw new Error("Volume doesn't exist: "+vol);
	}
	var path = vol+'/';
	folders.forEach(function(f){
		path += f+'/';
		if (!fs.existsSync(path)){
			try{
				fs.mkdirSync(path);
			}catch(e){
				throw new Error("Couldn't create folder: "+path);
			}
		}
	});
	return fs.createWriteStream(fn);
},

/**
 * Deletes folder and all files and subfolders (recursive).
 *
 * @param {string} dir
 */
deleteFolder: function(dir) {
	var self = this;
	
  if (!fs.existsSync(dir)) return;
	if (dir.charAt(dir.length-1)!='/') dir += '/';
	var items = fs.readdirSync(dir);
  
	items.forEach(function(name){
		var path = dir+name;
		var stats = fs.statSync(path);
		if (stats.isFile()){
			fs.unlinkSync(path);
		}else if (stats.isDirectory()){
			self.deleteFolder(path+'/', files);
		}
	});
	fs.rmdirSync(dir);
}


};
