// ENCODING: UTF-8
'use strict';

// BUILT-IN MODULES
var fs = require('fs');

// EXTERNAL MODULES
var qt = require('./../../../lib/node-qt');
var xml2js = require('./../xml2js');

var format = {};
format['name'] = 'FileZilla';
format['spec'] = 'sitemanager.xml';
format['load'] = function(fn, cb){
	var parser = new xml2js.Parser({async:false});
	var data = fs.readFileSync(fn, 'binary'); // ?
	parser.parseString(data, function(err, res){
		if (err) return false;
		var sites = {};
		res['FileZilla3']['Servers'][0].Server.forEach(function(info){
			var site = {};
			if (info.Protocol[0]=='0'){ // FTP
				site.host = info.Host[0];
				site.port = info.Port[0]*1; // (info.port || '21')*1;	
				//if (info.auth){
					site.user = info.User[0];
					site.pass = info.Pass[0];
				//}
				if (info.RemoteDir) site.rdir = info.RemoteDir[0];
				var name = info.Name[0];
				sites[name] = site;
			}
		});
		cb(sites);
		
	});
}

module.exports = format;