// ENCODING: UTF-8
'use strict';

// BUILT-IN MODULES
var fs = require('fs');
var url = require('url');

// EXTERNAL MODULES

var format = {};
format['name'] = 'URL List';
format['default'] = true;
format['spec'] = '*.*'; // *.txt;*.*
format['load'] = function(fn, cb){
	var data = fs.readFileSync(fn, 'binary');
	var lines = data.split(/\r?\n/);
	if (lines[lines.length-1]=='') lines.pop();
	var sites = {};
	lines.forEach(function(line){
		var info = url.parse(line);
		var site = {};
		site.host = info.host;
		if (info.port) site.port = info.port*1; // (info.port || '21')*1;	
		if (info.auth){
			var tmp = info.auth.split(':');
			site.user = tmp[0];
			site.pass = tmp.length>1?tmp[1]:'';
		}
		if (info.path) site.rdir = info.path; 
		// make unique name
		var name = info.host;
		sites[name] = site;
	});
	cb(sites);	
}

module.exports = format;