// ENCODING: UTF-8
'use strict';

/**
 * ImportSites-Plugin for fxFTP
 *
 * @author Valentin Schmidt
 * @copyright Valentin Schmidt 2013
 * @version 0.1
 *
 * @todo ...
 */
 
// DEPENDS ON GLOBALS:
// - sites

// BUILT-IN MODULES
var fs = require('fs');

// EXTERNAL MODULES
var fx = require('./../../lib/fx-utils');
var qt = require('./../../lib/node-qt');


// START IMPORTSITES-PLUGIN MODULE
module.exports = function(app){
	var formats = {};
	var filter = '';
	var defaultFormat;
	fs.readdir(__dirname+'/formats', function(err, files){
		files.forEach(function(f){
			var format = require('./formats/'+f);
			if (filter!='') filter += ';;';
			filter += format['name']+' ('+format['spec']+')';
			formats[format['spec']] = format;
			if (format['default']) defaultFormat = format;
		});
	})
	app.actions.importsites = new qt.QAction('&Import Sites...');
	app.menus.file.insertAction(app.actions.exit, app.actions.importsites);
	app.menus.file.insertSeparator(app.actions.exit);
	app.actions.importsites.on('triggered', function(n){
		var fn = qt.QFileDialog.getOpenFileName('', '', filter);
		if (!fn) return;
		var basename = fn.split('/').pop().toLowerCase();
		var format = formats[basename];
		if (!format && defaultFormat) format = defaultFormat;
		if (format){
			format['load'](fn, function(sites){
				if (sites){
					for (var name in sites){
						var site = sites[name];
						while (global.sites[name]!=undefined) name += '~';
						global.sites[name] = site;
					}
					// UPDATE SITES
					global.sites = fx.sortByKey(global.sites); // re-sort
					app.sitesChanged();
					app.siteManager.updateList();
				}
			});
		}
	});
}
