// ENCODING: UTF-8
'use strict';

/**
 * MinimizeToTray-Plugin for fxFTP
 *
 * @author Valentin Schmidt
 * @copyright Valentin Schmidt 2013
 * @version 0.1
 *
 * @todo ...
 */

// EXTERNAL MODULES
var qt = require('./../../lib/node-qt');


// START MINIMIZETOTRAY-PLUGIN MODULE
module.exports = function(app){
	//console.log('Loading MinimizeToTray Plugin');

	var systemTrayIcon = new qt.QSystemTrayIcon;
	var mainWindow = app.mainWindow;
		
	systemTrayIcon.setIcon(__dirname + '/app.png');
	systemTrayIcon.setToolTip(app.appName);
	
	systemTrayIcon.on('activated', function(activationReason){
		//if (activationReason==qt.ACTIVATIONREASON.TRIGGER){
		//if (activationReason==qt.ACTIVATIONREASON.DOUBLECLICK){
		mainWindow.setWindowState((mainWindow.windowState()&~qt.WINDOWSTATE.WINDOWMINIMIZED)|qt.WINDOWSTATE.WINDOWACTIVE);
		mainWindow.show();
		mainWindow.activateWindow();
		systemTrayIcon.hide();
	});

	mainWindow.addListener('changeEvent', function(e){
		if (e.type()==qt.EVENTTYPE.WINDOWSTATECHANGE){
	  	if (mainWindow.isMinimized()) {
	  		e.ignore();
	  		//app.processEvents();
	      //mainWindow.hide();
	      setTimeout(function(){mainWindow.hide()}, 0);
				systemTrayIcon.show();
	  	}
		}
	});
	
	process.on('exit', function(){
		systemTrayIcon.hide();
		systemTrayIcon.destroy();
	});
	
}
