// ENCODING: UTF-8
'use strict';

// BUILT-IN MODULES
var fs = require('fs');

// EXTERNAL MODULES
var iniparser = require('./../iniparser');
var qt = require('./../../../lib/node-qt');

//################################################
// UltraEdit
// http://www.exploit-db.com/exploits/21091/&strip=1
//################################################

var format = {};
format['name'] = 'UltraEdit';
format['spec'] = 'FTP.INI';
format['load'] = function(fn, cb){
	var ok = qt.confirm('Unfortunately current UltraEdit passsword encryption scheme is unknown, therefor passwords are not imported. Import sites anyway?\n\n(If you know how to decrypt those passwords, please contact the creator of this plugin)', 'UltraEdit FTP Site Import');
	if (!ok) return false;
	var data = iniparser.parseSync(fn);
	var uids = data['FTP Account List'];
	var sites = {};
	for (var i in uids){
		var uid = uids[i];
		var info = data[uid];
		if (info['Protocol']=='0'){ // FTP
			var site = {};
			site.host = info['Server Address'];
			site.port = info['Port']*1;
			if (info['User Name']){
				site.user = info['User Name'];
				site.pass = ''; // info['Password'];
			}
			if (info['Initial Directory']) site.rdir = info['Initial Directory'];

			var name = info['Account Name'];
			sites[name] = site;
		}
	}
	cb(sites);
}

module.exports = format;